<!DOCTYPE html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <title>Dashboard for /var/www/html/app</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link href="_css/bootstrap.min.css?v=9.2.26" rel="stylesheet" type="text/css">
  <link href="_css/nv.d3.min.css?v=9.2.26" rel="stylesheet" type="text/css">
  <link href="_css/style.css?v=9.2.26" rel="stylesheet" type="text/css">
  <link href="_css/custom.css" rel="stylesheet" type="text/css">
 </head>
 <body>
  <header>
   <div class="container-fluid">
    <div class="row">
     <div class="col-md-12">
      <nav aria-label="breadcrumb">
       <ol class="breadcrumb">
         <li class="breadcrumb-item"><a href="index.html">/var/www/html/app</a></li>
         <li class="breadcrumb-item active">(Dashboard)</li>

       </ol>
      </nav>
     </div>
    </div>
   </div>
  </header>
  <div class="container-fluid">
   <div class="row">
    <div class="col-md-12">
     <h2>Classes</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="classCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="classComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Events/OrderShipped.php.html#14">App\Events\OrderShipped</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Exceptions/Handler.php.html#9">App\Exceptions\Handler</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#16">App\Http\Controllers\HomeController</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#8">App\Http\Controllers\Photo2Controller</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#7">App\Http\Controllers\PhotoController</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#13">App\Http\Controllers\ProductController</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Middleware/Authenticate.php.html#7">App\Http\Middleware\Authenticate</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Middleware/RedirectIfAuthenticated.php.html#10">App\Http\Middleware\RedirectIfAuthenticated</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Middleware/TrustHosts.php.html#7">App\Http\Middleware\TrustHosts</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/PostFormRequest.php.html#7">App\Http\Requests\PostFormRequest</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/StoreProductRequest.php.html#7">App\Http\Requests\StoreProductRequest</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Listeners/SendShipmentNotification.php.html#9">App\Listeners\SendShipmentNotification</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Mail/CategoryShipped.php.html#11">App\Mail\CategoryShipped</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Mail/OrderShipped.php.html#12">App\Mail\OrderShipped</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Comment.php.html#9">App\Models\Comment</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Customer.php.html#10">App\Models\Customer</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Product.php.html#12">App\Models\Product</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/ProductObserver.php.html#7">App\Observers\ProductObserver</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Providers/BroadcastServiceProvider.php.html#8">App\Providers\BroadcastServiceProvider</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Alert.php.html#7">App\View\Components\Alert</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Inputs/Button.php.html#7">App\View\Components\Inputs\Button</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Layout.php.html#7">App\View\Components\Layout</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/CategoryObserver.php.html#12">App\Observers\CategoryObserver</a></td><td class="text-right">20%</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#16">App\Http\Controllers\CategoryController</a></td><td class="text-right">30%</td></tr>
       <tr><td><a href="Models/Category.php.html#11">App\Models\Category</a></td><td class="text-right">60%</td></tr>
       <tr><td><a href="Console/Kernel.php.html#8">App\Console\Kernel</a></td><td class="text-right">66%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Http/Controllers/ProductController.php.html#13">App\Http\Controllers\ProductController</a></td><td class="text-right">90</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#16">App\Http\Controllers\HomeController</a></td><td class="text-right">72</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#16">App\Http\Controllers\CategoryController</a></td><td class="text-right">23</td></tr>
       <tr><td><a href="Http/Middleware/RedirectIfAuthenticated.php.html#10">App\Http\Middleware\RedirectIfAuthenticated</a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Http/Middleware/Authenticate.php.html#7">App\Http\Middleware\Authenticate</a></td><td class="text-right">6</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-12">
     <h2>Methods</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="methodCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="methodComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Console/Kernel.php.html#16"><abbr title="App\Console\Kernel::schedule">schedule</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Events/OrderShipped.php.html#24"><abbr title="App\Events\OrderShipped::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Events/OrderShipped.php.html#34"><abbr title="App\Events\OrderShipped::broadcastOn">broadcastOn</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Exceptions/Handler.php.html#36"><abbr title="App\Exceptions\Handler::register">register</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#51"><abbr title="App\Http\Controllers\CategoryController::destroy">destroy</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#61"><abbr title="App\Http\Controllers\CategoryController::show">show</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#66"><abbr title="App\Http\Controllers\CategoryController::edit">edit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#80"><abbr title="App\Http\Controllers\CategoryController::update">update</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#23"><abbr title="App\Http\Controllers\HomeController::index">index</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#60"><abbr title="App\Http\Controllers\HomeController::create">create</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#71"><abbr title="App\Http\Controllers\HomeController::store">store</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#87"><abbr title="App\Http\Controllers\HomeController::show">show</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#98"><abbr title="App\Http\Controllers\HomeController::edit">edit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#110"><abbr title="App\Http\Controllers\HomeController::update">update</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#121"><abbr title="App\Http\Controllers\HomeController::destroy">destroy</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#15"><abbr title="App\Http\Controllers\Photo2Controller::index">index</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#25"><abbr title="App\Http\Controllers\Photo2Controller::create">create</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#36"><abbr title="App\Http\Controllers\Photo2Controller::store">store</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#47"><abbr title="App\Http\Controllers\Photo2Controller::show">show</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#58"><abbr title="App\Http\Controllers\Photo2Controller::edit">edit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#70"><abbr title="App\Http\Controllers\Photo2Controller::update">update</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/Photo2Controller.php.html#81"><abbr title="App\Http\Controllers\Photo2Controller::destroy">destroy</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#14"><abbr title="App\Http\Controllers\PhotoController::index">index</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#24"><abbr title="App\Http\Controllers\PhotoController::create">create</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#35"><abbr title="App\Http\Controllers\PhotoController::store">store</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#46"><abbr title="App\Http\Controllers\PhotoController::show">show</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#57"><abbr title="App\Http\Controllers\PhotoController::edit">edit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#69"><abbr title="App\Http\Controllers\PhotoController::update">update</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/PhotoController.php.html#80"><abbr title="App\Http\Controllers\PhotoController::destroy">destroy</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#19"><abbr title="App\Http\Controllers\ProductController::index">index</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#26"><abbr title="App\Http\Controllers\ProductController::addCart">addCart</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#49"><abbr title="App\Http\Controllers\ProductController::create">create</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#58"><abbr title="App\Http\Controllers\ProductController::store">store</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#77"><abbr title="App\Http\Controllers\ProductController::show">show</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#88"><abbr title="App\Http\Controllers\ProductController::edit">edit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#100"><abbr title="App\Http\Controllers\ProductController::update">update</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#111"><abbr title="App\Http\Controllers\ProductController::destroy">destroy</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Middleware/Authenticate.php.html#15"><abbr title="App\Http\Middleware\Authenticate::redirectTo">redirectTo</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Middleware/RedirectIfAuthenticated.php.html#20"><abbr title="App\Http\Middleware\RedirectIfAuthenticated::handle">handle</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Middleware/TrustHosts.php.html#14"><abbr title="App\Http\Middleware\TrustHosts::hosts">hosts</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/PostFormRequest.php.html#15"><abbr title="App\Http\Requests\PostFormRequest::authorize">authorize</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/PostFormRequest.php.html#25"><abbr title="App\Http\Requests\PostFormRequest::rules">rules</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/StoreProductRequest.php.html#14"><abbr title="App\Http\Requests\StoreProductRequest::authorize">authorize</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/StoreProductRequest.php.html#24"><abbr title="App\Http\Requests\StoreProductRequest::rules">rules</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Requests/StoreProductRequest.php.html#32"><abbr title="App\Http\Requests\StoreProductRequest::mess">mess</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Listeners/SendShipmentNotification.php.html#16"><abbr title="App\Listeners\SendShipmentNotification::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Listeners/SendShipmentNotification.php.html#27"><abbr title="App\Listeners\SendShipmentNotification::handle">handle</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Mail/CategoryShipped.php.html#22"><abbr title="App\Mail\CategoryShipped::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Mail/CategoryShipped.php.html#32"><abbr title="App\Mail\CategoryShipped::build">build</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Mail/OrderShipped.php.html#23"><abbr title="App\Mail\OrderShipped::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Mail/OrderShipped.php.html#33"><abbr title="App\Mail\OrderShipped::build">build</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Category.php.html#31"><abbr title="App\Models\Category::product">product</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Category.php.html#36"><abbr title="App\Models\Category::selectMy">selectMy</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Comment.php.html#13"><abbr title="App\Models\Comment::user">user</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Customer.php.html#14"><abbr title="App\Models\Customer::comments">comments</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Product.php.html#28"><abbr title="App\Models\Product::getSlugOptions">getSlugOptions</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Models/Product.php.html#35"><abbr title="App\Models\Product::category">category</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/CategoryObserver.php.html#31"><abbr title="App\Observers\CategoryObserver::updated">updated</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/CategoryObserver.php.html#42"><abbr title="App\Observers\CategoryObserver::deleted">deleted</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/CategoryObserver.php.html#53"><abbr title="App\Observers\CategoryObserver::restored">restored</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/CategoryObserver.php.html#64"><abbr title="App\Observers\CategoryObserver::forceDeleted">forceDeleted</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/ProductObserver.php.html#15"><abbr title="App\Observers\ProductObserver::created">created</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/ProductObserver.php.html#26"><abbr title="App\Observers\ProductObserver::updated">updated</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/ProductObserver.php.html#37"><abbr title="App\Observers\ProductObserver::deleted">deleted</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/ProductObserver.php.html#48"><abbr title="App\Observers\ProductObserver::restored">restored</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Observers/ProductObserver.php.html#59"><abbr title="App\Observers\ProductObserver::forceDeleted">forceDeleted</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Providers/BroadcastServiceProvider.php.html#15"><abbr title="App\Providers\BroadcastServiceProvider::boot">boot</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Alert.php.html#16"><abbr title="App\View\Components\Alert::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Alert.php.html#25"><abbr title="App\View\Components\Alert::render">render</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Inputs/Button.php.html#14"><abbr title="App\View\Components\Inputs\Button::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Inputs/Button.php.html#24"><abbr title="App\View\Components\Inputs\Button::render">render</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Layout.php.html#14"><abbr title="App\View\Components\Layout::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="View/Components/Layout.php.html#24"><abbr title="App\View\Components\Layout::render">render</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#32"><abbr title="App\Http\Controllers\CategoryController::store">store</abbr></a></td><td class="text-right">60%</td></tr>
       <tr><td><a href="Providers/RouteServiceProvider.php.html#57"><abbr title="App\Providers\RouteServiceProvider::configureRateLimiting">configureRateLimiting</abbr></a></td><td class="text-right">66%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Http/Middleware/RedirectIfAuthenticated.php.html#20"><abbr title="App\Http\Middleware\RedirectIfAuthenticated::handle">handle</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Http/Controllers/HomeController.php.html#71"><abbr title="App\Http\Controllers\HomeController::store">store</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Http/Controllers/ProductController.php.html#58"><abbr title="App\Http\Controllers\ProductController::store">store</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Http/Middleware/Authenticate.php.html#15"><abbr title="App\Http\Middleware\Authenticate::redirectTo">redirectTo</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Http/Controllers/CategoryController.php.html#32"><abbr title="App\Http\Controllers\CategoryController::store">store</abbr></a></td><td class="text-right">2</td></tr>
       <tr><td><a href="Providers/RouteServiceProvider.php.html#57"><abbr title="App\Providers\RouteServiceProvider::configureRateLimiting">configureRateLimiting</abbr></a></td><td class="text-right">2</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <footer>
    <hr/>
    <p>
     <small>Generated by <a href="https://github.com/sebastianbergmann/php-code-coverage" target="_top">php-code-coverage 9.2.26</a> using <a href="https://secure.php.net/" target="_top">PHP 8.0.28</a> and <a href="https://phpunit.de/">PHPUnit 9.6.8</a> at Mon Aug 7 19:08:16 UTC 2023.</small>
    </p>
   </footer>
  </div>
  <script src="_js/jquery.min.js?v=9.2.26" type="text/javascript"></script>
  <script src="_js/d3.min.js?v=9.2.26" type="text/javascript"></script>
  <script src="_js/nv.d3.min.js?v=9.2.26" type="text/javascript"></script>
  <script type="text/javascript">
$(document).ready(function() {
  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#classCoverageDistribution svg')
      .datum(getCoverageDistributionData([22,0,0,1,1,0,0,2,0,0,1,18], "Class Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#methodCoverageDistribution svg')
      .datum(getCoverageDistributionData([73,0,0,0,0,0,0,2,0,0,0,13], "Method Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getCoverageDistributionData(data, label) {
    var labels = [
      '0%',
      '0-10%',
      '10-20%',
      '20-30%',
      '30-40%',
      '40-50%',
      '50-60%',
      '60-70%',
      '70-80%',
      '80-90%',
      '90-100%',
      '100%'
    ];
    var values = [];
    $.each(labels, function(key) {
      values.push({x: labels[key], y: data[key]});
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Cyclomatic Complexity');

    d3.select('#classComplexity svg')
      .datum(getComplexityData([[66.66666666666666,2,"<a href=\"Console\/Kernel.php.html#8\">App\\Console\\Kernel<\/a>"],[0,2,"<a href=\"Events\/OrderShipped.php.html#14\">App\\Events\\OrderShipped<\/a>"],[0,1,"<a href=\"Exceptions\/Handler.php.html#9\">App\\Exceptions\\Handler<\/a>"],[30.76923076923077,7,"<a href=\"Http\/Controllers\/CategoryController.php.html#16\">App\\Http\\Controllers\\CategoryController<\/a>"],[100,0,"<a href=\"Http\/Controllers\/Controller.php.html#10\">App\\Http\\Controllers\\Controller<\/a>"],[100,0,"<a href=\"Http\/Controllers\/FlightController.php.html#7\">App\\Http\\Controllers\\FlightController<\/a>"],[0,8,"<a href=\"Http\/Controllers\/HomeController.php.html#16\">App\\Http\\Controllers\\HomeController<\/a>"],[100,0,"<a href=\"Http\/Controllers\/OrderController.php.html#7\">App\\Http\\Controllers\\OrderController<\/a>"],[0,7,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#8\">App\\Http\\Controllers\\Photo2Controller<\/a>"],[0,7,"<a href=\"Http\/Controllers\/PhotoController.php.html#7\">App\\Http\\Controllers\\PhotoController<\/a>"],[0,9,"<a href=\"Http\/Controllers\/ProductController.php.html#13\">App\\Http\\Controllers\\ProductController<\/a>"],[100,0,"<a href=\"Http\/Kernel.php.html#7\">App\\Http\\Kernel<\/a>"],[0,2,"<a href=\"Http\/Middleware\/Authenticate.php.html#7\">App\\Http\\Middleware\\Authenticate<\/a>"],[100,0,"<a href=\"Http\/Middleware\/EncryptCookies.php.html#7\">App\\Http\\Middleware\\EncryptCookies<\/a>"],[100,0,"<a href=\"Http\/Middleware\/PreventRequestsDuringMaintenance.php.html#7\">App\\Http\\Middleware\\PreventRequestsDuringMaintenance<\/a>"],[0,4,"<a href=\"Http\/Middleware\/RedirectIfAuthenticated.php.html#10\">App\\Http\\Middleware\\RedirectIfAuthenticated<\/a>"],[100,0,"<a href=\"Http\/Middleware\/TrimStrings.php.html#7\">App\\Http\\Middleware\\TrimStrings<\/a>"],[0,1,"<a href=\"Http\/Middleware\/TrustHosts.php.html#7\">App\\Http\\Middleware\\TrustHosts<\/a>"],[100,0,"<a href=\"Http\/Middleware\/TrustProxies.php.html#8\">App\\Http\\Middleware\\TrustProxies<\/a>"],[100,0,"<a href=\"Http\/Middleware\/VerifyCsrfToken.php.html#7\">App\\Http\\Middleware\\VerifyCsrfToken<\/a>"],[0,2,"<a href=\"Http\/Requests\/PostFormRequest.php.html#7\">App\\Http\\Requests\\PostFormRequest<\/a>"],[100,2,"<a href=\"Http\/Requests\/StoreCategoryRequest.php.html#7\">App\\Http\\Requests\\StoreCategoryRequest<\/a>"],[0,3,"<a href=\"Http\/Requests\/StoreProductRequest.php.html#7\">App\\Http\\Requests\\StoreProductRequest<\/a>"],[100,2,"<a href=\"Jobs\/ProcessPodcast.php.html#16\">App\\Jobs\\ProcessPodcast<\/a>"],[0,2,"<a href=\"Listeners\/SendShipmentNotification.php.html#9\">App\\Listeners\\SendShipmentNotification<\/a>"],[0,2,"<a href=\"Mail\/CategoryShipped.php.html#11\">App\\Mail\\CategoryShipped<\/a>"],[0,2,"<a href=\"Mail\/OrderShipped.php.html#12\">App\\Mail\\OrderShipped<\/a>"],[100,0,"<a href=\"Models\/Brand.php.html#8\">App\\Models\\Brand<\/a>"],[60,3,"<a href=\"Models\/Category.php.html#11\">App\\Models\\Category<\/a>"],[0,1,"<a href=\"Models\/Comment.php.html#9\">App\\Models\\Comment<\/a>"],[0,1,"<a href=\"Models\/Customer.php.html#10\">App\\Models\\Customer<\/a>"],[100,0,"<a href=\"Models\/Flight.php.html#9\">App\\Models\\Flight<\/a>"],[100,0,"<a href=\"Models\/Order.php.html#8\">App\\Models\\Order<\/a>"],[0,2,"<a href=\"Models\/Product.php.html#12\">App\\Models\\Product<\/a>"],[100,0,"<a href=\"Models\/User.php.html#11\">App\\Models\\User<\/a>"],[20,5,"<a href=\"Observers\/CategoryObserver.php.html#12\">App\\Observers\\CategoryObserver<\/a>"],[0,5,"<a href=\"Observers\/ProductObserver.php.html#7\">App\\Observers\\ProductObserver<\/a>"],[100,2,"<a href=\"Providers\/AppServiceProvider.php.html#8\">App\\Providers\\AppServiceProvider<\/a>"],[100,1,"<a href=\"Providers\/AuthServiceProvider.php.html#8\">App\\Providers\\AuthServiceProvider<\/a>"],[0,1,"<a href=\"Providers\/BroadcastServiceProvider.php.html#8\">App\\Providers\\BroadcastServiceProvider<\/a>"],[100,1,"<a href=\"Providers\/EventServiceProvider.php.html#14\">App\\Providers\\EventServiceProvider<\/a>"],[92.3076923076923,3,"<a href=\"Providers\/RouteServiceProvider.php.html#11\">App\\Providers\\RouteServiceProvider<\/a>"],[0,2,"<a href=\"View\/Components\/Alert.php.html#7\">App\\View\\Components\\Alert<\/a>"],[0,2,"<a href=\"View\/Components\/Inputs\/Button.php.html#7\">App\\View\\Components\\Inputs\\Button<\/a>"],[0,2,"<a href=\"View\/Components\/Layout.php.html#7\">App\\View\\Components\\Layout<\/a>"]], 'Class Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Method Complexity');

    d3.select('#methodComplexity svg')
      .datum(getComplexityData([[0,1,"<a href=\"Console\/Kernel.php.html#16\">App\\Console\\Kernel::schedule<\/a>"],[100,1,"<a href=\"Console\/Kernel.php.html#26\">App\\Console\\Kernel::commands<\/a>"],[0,1,"<a href=\"Events\/OrderShipped.php.html#24\">App\\Events\\OrderShipped::__construct<\/a>"],[0,1,"<a href=\"Events\/OrderShipped.php.html#34\">App\\Events\\OrderShipped::broadcastOn<\/a>"],[0,1,"<a href=\"Exceptions\/Handler.php.html#36\">App\\Exceptions\\Handler::register<\/a>"],[100,1,"<a href=\"Http\/Controllers\/CategoryController.php.html#22\">App\\Http\\Controllers\\CategoryController::index<\/a>"],[60,2,"<a href=\"Http\/Controllers\/CategoryController.php.html#32\">App\\Http\\Controllers\\CategoryController::store<\/a>"],[0,1,"<a href=\"Http\/Controllers\/CategoryController.php.html#51\">App\\Http\\Controllers\\CategoryController::destroy<\/a>"],[0,1,"<a href=\"Http\/Controllers\/CategoryController.php.html#61\">App\\Http\\Controllers\\CategoryController::show<\/a>"],[0,1,"<a href=\"Http\/Controllers\/CategoryController.php.html#66\">App\\Http\\Controllers\\CategoryController::edit<\/a>"],[0,1,"<a href=\"Http\/Controllers\/CategoryController.php.html#80\">App\\Http\\Controllers\\CategoryController::update<\/a>"],[0,1,"<a href=\"Http\/Controllers\/HomeController.php.html#23\">App\\Http\\Controllers\\HomeController::index<\/a>"],[0,1,"<a href=\"Http\/Controllers\/HomeController.php.html#60\">App\\Http\\Controllers\\HomeController::create<\/a>"],[0,2,"<a href=\"Http\/Controllers\/HomeController.php.html#71\">App\\Http\\Controllers\\HomeController::store<\/a>"],[0,1,"<a href=\"Http\/Controllers\/HomeController.php.html#87\">App\\Http\\Controllers\\HomeController::show<\/a>"],[0,1,"<a href=\"Http\/Controllers\/HomeController.php.html#98\">App\\Http\\Controllers\\HomeController::edit<\/a>"],[0,1,"<a href=\"Http\/Controllers\/HomeController.php.html#110\">App\\Http\\Controllers\\HomeController::update<\/a>"],[0,1,"<a href=\"Http\/Controllers\/HomeController.php.html#121\">App\\Http\\Controllers\\HomeController::destroy<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#15\">App\\Http\\Controllers\\Photo2Controller::index<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#25\">App\\Http\\Controllers\\Photo2Controller::create<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#36\">App\\Http\\Controllers\\Photo2Controller::store<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#47\">App\\Http\\Controllers\\Photo2Controller::show<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#58\">App\\Http\\Controllers\\Photo2Controller::edit<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#70\">App\\Http\\Controllers\\Photo2Controller::update<\/a>"],[0,1,"<a href=\"Http\/Controllers\/Photo2Controller.php.html#81\">App\\Http\\Controllers\\Photo2Controller::destroy<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#14\">App\\Http\\Controllers\\PhotoController::index<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#24\">App\\Http\\Controllers\\PhotoController::create<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#35\">App\\Http\\Controllers\\PhotoController::store<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#46\">App\\Http\\Controllers\\PhotoController::show<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#57\">App\\Http\\Controllers\\PhotoController::edit<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#69\">App\\Http\\Controllers\\PhotoController::update<\/a>"],[0,1,"<a href=\"Http\/Controllers\/PhotoController.php.html#80\">App\\Http\\Controllers\\PhotoController::destroy<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#19\">App\\Http\\Controllers\\ProductController::index<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#26\">App\\Http\\Controllers\\ProductController::addCart<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#49\">App\\Http\\Controllers\\ProductController::create<\/a>"],[0,2,"<a href=\"Http\/Controllers\/ProductController.php.html#58\">App\\Http\\Controllers\\ProductController::store<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#77\">App\\Http\\Controllers\\ProductController::show<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#88\">App\\Http\\Controllers\\ProductController::edit<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#100\">App\\Http\\Controllers\\ProductController::update<\/a>"],[0,1,"<a href=\"Http\/Controllers\/ProductController.php.html#111\">App\\Http\\Controllers\\ProductController::destroy<\/a>"],[0,2,"<a href=\"Http\/Middleware\/Authenticate.php.html#15\">App\\Http\\Middleware\\Authenticate::redirectTo<\/a>"],[0,4,"<a href=\"Http\/Middleware\/RedirectIfAuthenticated.php.html#20\">App\\Http\\Middleware\\RedirectIfAuthenticated::handle<\/a>"],[0,1,"<a href=\"Http\/Middleware\/TrustHosts.php.html#14\">App\\Http\\Middleware\\TrustHosts::hosts<\/a>"],[0,1,"<a href=\"Http\/Requests\/PostFormRequest.php.html#15\">App\\Http\\Requests\\PostFormRequest::authorize<\/a>"],[0,1,"<a href=\"Http\/Requests\/PostFormRequest.php.html#25\">App\\Http\\Requests\\PostFormRequest::rules<\/a>"],[100,1,"<a href=\"Http\/Requests\/StoreCategoryRequest.php.html#14\">App\\Http\\Requests\\StoreCategoryRequest::authorize<\/a>"],[100,1,"<a href=\"Http\/Requests\/StoreCategoryRequest.php.html#24\">App\\Http\\Requests\\StoreCategoryRequest::rules<\/a>"],[0,1,"<a href=\"Http\/Requests\/StoreProductRequest.php.html#14\">App\\Http\\Requests\\StoreProductRequest::authorize<\/a>"],[0,1,"<a href=\"Http\/Requests\/StoreProductRequest.php.html#24\">App\\Http\\Requests\\StoreProductRequest::rules<\/a>"],[0,1,"<a href=\"Http\/Requests\/StoreProductRequest.php.html#32\">App\\Http\\Requests\\StoreProductRequest::mess<\/a>"],[100,1,"<a href=\"Jobs\/ProcessPodcast.php.html#25\">App\\Jobs\\ProcessPodcast::__construct<\/a>"],[100,1,"<a href=\"Jobs\/ProcessPodcast.php.html#36\">App\\Jobs\\ProcessPodcast::handle<\/a>"],[0,1,"<a href=\"Listeners\/SendShipmentNotification.php.html#16\">App\\Listeners\\SendShipmentNotification::__construct<\/a>"],[0,1,"<a href=\"Listeners\/SendShipmentNotification.php.html#27\">App\\Listeners\\SendShipmentNotification::handle<\/a>"],[0,1,"<a href=\"Mail\/CategoryShipped.php.html#22\">App\\Mail\\CategoryShipped::__construct<\/a>"],[0,1,"<a href=\"Mail\/CategoryShipped.php.html#32\">App\\Mail\\CategoryShipped::build<\/a>"],[0,1,"<a href=\"Mail\/OrderShipped.php.html#23\">App\\Mail\\OrderShipped::__construct<\/a>"],[0,1,"<a href=\"Mail\/OrderShipped.php.html#33\">App\\Mail\\OrderShipped::build<\/a>"],[100,1,"<a href=\"Models\/Category.php.html#24\">App\\Models\\Category::getSlugOptions<\/a>"],[0,1,"<a href=\"Models\/Category.php.html#31\">App\\Models\\Category::product<\/a>"],[0,1,"<a href=\"Models\/Category.php.html#36\">App\\Models\\Category::selectMy<\/a>"],[0,1,"<a href=\"Models\/Comment.php.html#13\">App\\Models\\Comment::user<\/a>"],[0,1,"<a href=\"Models\/Customer.php.html#14\">App\\Models\\Customer::comments<\/a>"],[0,1,"<a href=\"Models\/Product.php.html#28\">App\\Models\\Product::getSlugOptions<\/a>"],[0,1,"<a href=\"Models\/Product.php.html#35\">App\\Models\\Product::category<\/a>"],[100,1,"<a href=\"Observers\/CategoryObserver.php.html#20\">App\\Observers\\CategoryObserver::created<\/a>"],[0,1,"<a href=\"Observers\/CategoryObserver.php.html#31\">App\\Observers\\CategoryObserver::updated<\/a>"],[0,1,"<a href=\"Observers\/CategoryObserver.php.html#42\">App\\Observers\\CategoryObserver::deleted<\/a>"],[0,1,"<a href=\"Observers\/CategoryObserver.php.html#53\">App\\Observers\\CategoryObserver::restored<\/a>"],[0,1,"<a href=\"Observers\/CategoryObserver.php.html#64\">App\\Observers\\CategoryObserver::forceDeleted<\/a>"],[0,1,"<a href=\"Observers\/ProductObserver.php.html#15\">App\\Observers\\ProductObserver::created<\/a>"],[0,1,"<a href=\"Observers\/ProductObserver.php.html#26\">App\\Observers\\ProductObserver::updated<\/a>"],[0,1,"<a href=\"Observers\/ProductObserver.php.html#37\">App\\Observers\\ProductObserver::deleted<\/a>"],[0,1,"<a href=\"Observers\/ProductObserver.php.html#48\">App\\Observers\\ProductObserver::restored<\/a>"],[0,1,"<a href=\"Observers\/ProductObserver.php.html#59\">App\\Observers\\ProductObserver::forceDeleted<\/a>"],[100,1,"<a href=\"Providers\/AppServiceProvider.php.html#15\">App\\Providers\\AppServiceProvider::register<\/a>"],[100,1,"<a href=\"Providers\/AppServiceProvider.php.html#25\">App\\Providers\\AppServiceProvider::boot<\/a>"],[100,1,"<a href=\"Providers\/AuthServiceProvider.php.html#24\">App\\Providers\\AuthServiceProvider::boot<\/a>"],[0,1,"<a href=\"Providers\/BroadcastServiceProvider.php.html#15\">App\\Providers\\BroadcastServiceProvider::boot<\/a>"],[100,1,"<a href=\"Providers\/EventServiceProvider.php.html#35\">App\\Providers\\EventServiceProvider::boot<\/a>"],[100,1,"<a href=\"Providers\/RouteServiceProvider.php.html#36\">App\\Providers\\RouteServiceProvider::boot<\/a>"],[66.66666666666666,2,"<a href=\"Providers\/RouteServiceProvider.php.html#57\">App\\Providers\\RouteServiceProvider::configureRateLimiting<\/a>"],[0,1,"<a href=\"View\/Components\/Alert.php.html#16\">App\\View\\Components\\Alert::__construct<\/a>"],[0,1,"<a href=\"View\/Components\/Alert.php.html#25\">App\\View\\Components\\Alert::render<\/a>"],[0,1,"<a href=\"View\/Components\/Inputs\/Button.php.html#14\">App\\View\\Components\\Inputs\\Button::__construct<\/a>"],[0,1,"<a href=\"View\/Components\/Inputs\/Button.php.html#24\">App\\View\\Components\\Inputs\\Button::render<\/a>"],[0,1,"<a href=\"View\/Components\/Layout.php.html#14\">App\\View\\Components\\Layout::__construct<\/a>"],[0,1,"<a href=\"View\/Components\/Layout.php.html#24\">App\\View\\Components\\Layout::render<\/a>"]], 'Method Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getComplexityData(data, label) {
    var values = [];
    $.each(data, function(key) {
      var value = Math.round(data[key][0]*100) / 100;
      values.push({
        x: value,
        y: data[key][1],
        class: data[key][2],
        size: 0.05,
        shape: 'diamond'
      });
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
});
  </script>
 </body>
</html>
